=== debian/changelog ===
pytorch (2.6.0+dfsg-9) unstable; urgency=medium

  * d/patches:
    + backport patch from upstream to support building with CMake 4.
    (closes: #1113436)
    + backport patch to support gloo API changes.

 -- Shengqi Chen <harry@debian.org>  Thu, 18 Sep 2025 19:51:27 +0800

pytorch (2.6.0+dfsg-8) unstable; urgency=medium

  [ Mo Zhou ]
  * Add missing B-D python3-numpy-dev for dh_numpy3.
  * Update lintian overrides for libtorch2.6.
  * Fix the libuv support for compatibility with vLLM:
    * Bump B-D on libgloo-dev (>= 0.0~git20231202.5354032-5) for libuv support.
    * Important packaging bugfix for libuv support in torch.distributed.
    * Let libtorch depend on libgloo (>= 0.0~git20231202.5354032-5) for libuv.
  * Specific to the CUDA variant:
    * [CUDA] Require cuda >= 12.4 (Closes: #1105066)
    * [CUDA] No longer build for ppc64el architecture.
    * [CUDA] Sync control with CPU version. Remove ppc64el architecture.

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Mo Zhou <lumin@debian.org>  Mon, 18 Aug 2025 19:16:13 -0400

pytorch (2.6.0+dfsg-7) unstable; urgency=medium

  [ Santiago Vila ]
  * Disable non-portable flags. (Closes: #1102472).

  [ Mo Zhou ]
  * The deprecated module python3-pkg-resources was already not needed
    since 2.5.0+dfsg-1. (Closes: #1083727, #1083730)
  * Cherry-pick upstream PR #143290 for bfloat16 FlexAttention.

 -- Mo Zhou <lumin@debian.org>  Fri, 11 Apr 2025 06:45:18 -0400

pytorch (2.6.0+dfsg-6) unstable; urgency=medium

  * Delete the draft of dh_pytorch. Already implemented in a simpler way.
  * [CUDA] Manual rebuild for cpp-httplib transition. (Closes: #1100688)

 -- Mo Zhou <lumin@debian.org>  Mon, 17 Mar 2025 12:57:44 -0400

pytorch (2.6.0+dfsg-5) unstable; urgency=medium

  * Bugfix in SOVERSION patch and add missing libraries in shlib file.
  * Update .shlibs dependency template for ROCm variant.
  * Do not install libc10d_cuda_test.so in library package.
  * Delete test binaries that pull libc10d_cuda_test.so.

 -- Mo Zhou <lumin@debian.org>  Mon, 10 Mar 2025 14:44:22 -0400

pytorch (2.6.0+dfsg-4) unstable; urgency=medium

  [ Christian Bayle ]
  * (Work-in-progress) d/rules: Fill missing bits for PyTorch ROCm .

  [ Mo Zhou ]
  * [CUDA] Correctly link against libnvtoolsext.so.1 (Closes: #1098962)
  * Generate *.shlibs to override the default dependency template.
    This makes packages built against libtorchX.Y to use the following
    dependency template:
      libtorchX.Y | libtorch-cuda-X.Y | libtorch-rocm-X.Y
  * Add .pydist files to override dependency template of python3-torch*.
    This makes packages built against python3-torch to use the following
    dependency template:
      python3-torch | python3-torch-cuda | python3-torch-rocm
  * Remove automatically generated files on clean.

 -- Mo Zhou <lumin@debian.org>  Wed, 05 Mar 2025 23:01:32 -0500

pytorch (2.6.0+dfsg-3) unstable; urgency=medium

  [ Mo Zhou ]
  * [CUDA] Fix autopkgtest dependency conflict.
  * autopkgtest: Skip train_mnist test on s390x due to being big-endian
    (closes: #1098784).

  [ Shengqi Chen ]
  * d/patches: add patch to disable SVE on arm64 to prevent SIGILL.

 -- Shengqi Chen <harry@debian.org>  Mon, 24 Feb 2025 14:36:09 +0800

pytorch (2.6.0+dfsg-2) unstable; urgency=medium

  [ Jordan Justen ]
  * d/rules: Upstream dropped USE_VULKAN_SHADERC_RUNTIME (v2.0.0)
  * d/rules: Upstream dropped USE_VULKAN_WRAPPER (v1.10.0)
  * debian: Enabled USE_VULKAN during build

  [ Mo Zhou ]
  * [CUDA] Update CUDA arch list to 5.0;6.0;7.0;7.5;8.0;8.6;9.0+PTX.
  * [ROCm] Add missing B-D libamdhip64-dev.
  * Sync the vulkan Build-Deps for CUDA and ROCm variants.
  * Dependency bugfix: do not allow co-existence of two libtorchX.Y
    versions.
  * autopkgtest:
    + Add real CNN training test using FashionMNIST.
    + Mark {pow,native}_test as flaky (failed on arm64).
    + Mark op_registration_test as flaky (failed on ppc64el).

  [ Shengqi Chen ]
  * d/patches: fix linkage to cpp-httplib in use-system-httplib.patch

 -- Shengqi Chen <harry@debian.org>  Fri, 21 Feb 2025 16:52:24 +0800

pytorch (2.6.0+dfsg-1) unstable; urgency=medium

  [ Mo Zhou ]
  * [CUDA] Do not use the too-new nvtx3.hpp header that does not exist
    in archive.

  [ Shengqi Chen ]
  * Add patch to fix FTBFS on arm64 with GCC 14 (see: #1094828)
  * Upload to unstable.

 -- Shengqi Chen <harry@debian.org>  Tue, 18 Feb 2025 01:54:23 +0800

pytorch (2.6.0+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 2.6.0+dfsg
  * d/copyright: exclude fbjni, composable_kernel and (not released) ci
    files from source tar
  * d/control: add myself to uploaders

 -- Shengqi Chen <harry@debian.org>  Fri, 31 Jan 2025 00:20:10 +0800

pytorch (2.6.0~rc9+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 2.6.0~rc9+dfsg
    + refresh existing patches
    + bump SONAME to libtorch2.6
    + update embedded kineto to 338140f58a28d599da3434ced4fd2d75dd1a213d
    + d/README.Source: update according to current status
  * d/patches: add fix for XNNPACK in dirtyhack.patch
  * d/copyright: remove vanished files and licenses
  * Remove some unused lintian overrides
  * d/control: adjust version requirements of libdnnl and libxnnpack in
    Build-Depends

 -- Shengqi Chen <harry@debian.org>  Tue, 28 Jan 2025 23:59:57 +0800

pytorch (2.5.1+dfsg-4) unstable; urgency=medium

  * Do not install unneeded shared objects, really.
  * Delete the test binary that pulls unneeded shared objects.

 -- Mo Zhou <lumin@debian.org>  Fri, 03 Jan 2025 13:13:08 -0500
