=== debian/tests/control ===
# Sanity test of python package
Test-Command: cd test/ ; python3 -c "import sys, torch as th; print(sys.version, th.__path__, th.__version__)"
Depends: python3-torch,
Restrictions: allow-stderr
Features: test-name=py_import_and_version

Test-Command: cd debian/tests ; python3 blas.py
Depends: python3-torch, libopenblas0
Restrictions: allow-stderr
Features: test-name=py_blas_openblas

Test-Command: cd debian/tests ; python3 blas.py
Depends: python3-torch, libblis4
Restrictions: allow-stderr
Features: test-name=py_blas_blis

Test-Command: cd debian/tests ; python3 sequential.py
Depends: python3-torch,
Restrictions: allow-stderr
Features: test-name=py_sequential

# Check dangling symbol links
#Test-Command: cd debian/tests ; export TH_PATH="$(python3 -c 'import torch; print(torch.__path__[0])')"; test -z "$(find ${TH_PATH}/lib -xtype l)"
#Depends: python3-torch,
#Restrictions: allow-stderr
#Features: test-name=py_torch_no_dangling_symlink

# We are only printing those for package maintainers. The find command may fail due to a dangling symlink from other packages.
Test-Command: cd debian/tests ; find /usr -xtype l -print || true
Depends: @
Restrictions: allow-stderr
Features: test-name=show_dangling_symlink_if_any

# Real functionality test
# We exclude s390x because the training data bytes are little-endian.
Test-Command: sh debian/tests/train-mnist.sh
Depends: @, python3-torchvision, dataset-fashion-mnist, libopenblas0
Restrictions: allow-stderr
Features: test-name=real_train_mnist
Architecture: !s390x

# Generating Autopkgtest Test Cases for the C++ Testing Programs
# Found 104 tests
#
# C++ test 1/104
Test-Command: /usr/lib/libtorch-test/CppSignature_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=1_of_104__cpptest__CppSignature_test
Restrictions: allow-stderr

# C++ test 2/104
Test-Command: /usr/lib/libtorch-test/Dict_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=2_of_104__cpptest__Dict_test
Restrictions: allow-stderr

# C++ test 3/104
Test-Command: /usr/lib/libtorch-test/Dimname_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=3_of_104__cpptest__Dimname_test
Restrictions: allow-stderr

# C++ test 4/104
Test-Command: /usr/lib/libtorch-test/IListRef_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=4_of_104__cpptest__IListRef_test
Restrictions: allow-stderr

# C++ test 5/104
Test-Command: /usr/lib/libtorch-test/KernelFunction_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=5_of_104__cpptest__KernelFunction_test
Restrictions: allow-stderr

# C++ test 6/104
Test-Command: /usr/lib/libtorch-test/List_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=6_of_104__cpptest__List_test
Restrictions: allow-stderr

# C++ test 7/104
Test-Command: /usr/lib/libtorch-test/MaybeOwned_test
