=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/pytorch/pytorch/releases
Matching-Pattern: https://github.com/[^"]*/pytorch-v@ANY_VERSION@@ARCHIVE_EXT@
Dversionmangle: auto
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pytorch-$1.tar.gz%
Repacksuffix: +dfsg
Searchmode: plain
